Index: /NEMO/trunk/src/ICE/icedyn_adv_umx.F90
===================================================================
--- /NEMO/trunk/src/ICE/icedyn_adv_umx.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/icedyn_adv_umx.F90	(revision 10425)
@@ -1562,90 +1694,94 @@
       !! **  Purpose :   compute flux limiter 
       !!----------------------------------------------------------------------
-      REAL(wp)                     , INTENT(in   )           ::   pdt          ! tracer time-step
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(in   )           ::   pu           ! ice i-velocity => u*e2
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(in   )           ::   puc          ! ice i-velocity *A => u*e2*a
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(in   )           ::   pt           ! ice tracer
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(inout)           ::   pfu_ho       ! high order flux
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(in   ), OPTIONAL ::   pfu_ups      ! upstream flux
+      REAL(wp)                   , INTENT(in   )           ::   pdt          ! tracer time-step
+      REAL(wp), DIMENSION (:,:  ), INTENT(in   )           ::   pu           ! ice i-velocity => u*e2
+      REAL(wp), DIMENSION (:,:,:), INTENT(in   )           ::   puc          ! ice i-velocity *A => u*e2*a
+      REAL(wp), DIMENSION (:,:,:), INTENT(in   )           ::   pt           ! ice tracer
+      REAL(wp), DIMENSION (:,:,:), INTENT(inout)           ::   pfu_ho       ! high order flux
+      REAL(wp), DIMENSION (:,:,:), INTENT(in   ), OPTIONAL ::   pfu_ups      ! upstream flux
       !
       REAL(wp) ::   Cr, Rjm, Rj, Rjp, uCFL, zpsi, zh3, zlimiter, Rr
-      INTEGER  ::   ji, jj    ! dummy loop indices
-      REAL(wp), DIMENSION (jpi,jpj) ::   zslpx       ! tracer slopes 
-      !!----------------------------------------------------------------------
-      !
-      DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1   ! vector opt.
-            zslpx(ji,jj) = ( pt(ji+1,jj) - pt(ji,jj) ) * umask(ji,jj,1)
+      INTEGER  ::   ji, jj, jl    ! dummy loop indices
+      REAL(wp), DIMENSION (jpi,jpj,jpl) ::   zslpx       ! tracer slopes 
+      !!----------------------------------------------------------------------
+      !
+      DO jl = 1, jpl
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zslpx(ji,jj,jl) = ( pt(ji+1,jj,jl) - pt(ji,jj,jl) ) * umask(ji,jj,1)
+            END DO
          END DO
       END DO
-      CALL lbc_lnk( zslpx, 'U', -1.)   ! lateral boundary cond.
+      CALL lbc_lnk( 'icedyn_adv_umx', zslpx, 'U', -1.)   ! lateral boundary cond.
       
-      DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1   ! vector opt.
-            uCFL = pdt * ABS( pu(ji,jj) ) * r1_e1e2t(ji,jj)
-
-            Rjm = zslpx(ji-1,jj)
-            Rj  = zslpx(ji  ,jj)
-            Rjp = zslpx(ji+1,jj)
-
-            IF( PRESENT(pfu_ups) ) THEN
-
-               IF( pu(ji,jj) > 0. ) THEN   ;   Rr = Rjm
-               ELSE                        ;   Rr = Rjp
+      DO jl = 1, jpl
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               uCFL = pdt * ABS( pu(ji,jj) ) * r1_e1e2t(ji,jj)
+               
+               Rjm = zslpx(ji-1,jj,jl)
+               Rj  = zslpx(ji  ,jj,jl)
+               Rjp = zslpx(ji+1,jj,jl)
+
+               IF( PRESENT(pfu_ups) ) THEN
+
+                  IF( pu(ji,jj) > 0. ) THEN   ;   Rr = Rjm
+                  ELSE                        ;   Rr = Rjp
+                  ENDIF
+
+                  zh3 = pfu_ho(ji,jj,jl) - pfu_ups(ji,jj,jl)     
+                  IF( Rj > 0. ) THEN
+                     zlimiter =  MAX( 0., MIN( zh3, MAX(-Rr * 0.5 * ABS(pu(ji,jj)),  &
+                        &        MIN( 2. * Rr * 0.5 * ABS(pu(ji,jj)),  zh3,  1.5 * Rj * 0.5 * ABS(pu(ji,jj)) ) ) ) )
+                  ELSE
+                     zlimiter = -MAX( 0., MIN(-zh3, MAX( Rr * 0.5 * ABS(pu(ji,jj)),  &
+                        &        MIN(-2. * Rr * 0.5 * ABS(pu(ji,jj)), -zh3, -1.5 * Rj * 0.5 * ABS(pu(ji,jj)) ) ) ) )
+                  ENDIF
+                  pfu_ho(ji,jj,jl) = pfu_ups(ji,jj,jl) + zlimiter
+
+               ELSE
+                  IF( Rj /= 0. ) THEN
+                     IF( pu(ji,jj) > 0. ) THEN   ;   Cr = Rjm / Rj
+                     ELSE                        ;   Cr = Rjp / Rj
+                     ENDIF
+                  ELSE
+                     Cr = 0.
+                     !IF( pu(ji,jj) > 0. ) THEN   ;   Cr = Rjm * 1.e20
+                     !ELSE                        ;   Cr = Rjp * 1.e20
+                     !ENDIF
+                  ENDIF
+
+                  ! -- superbee --
+                  zpsi = MAX( 0., MAX( MIN(1.,2.*Cr), MIN(2.,Cr) ) )
+                  ! -- van albada 2 --
+                  !!zpsi = 2.*Cr / (Cr*Cr+1.)
+
+                  ! -- sweby (with beta=1) --
+                  !!zpsi = MAX( 0., MAX( MIN(1.,1.*Cr), MIN(1.,Cr) ) )
+                  ! -- van Leer --
+                  !!zpsi = ( Cr + ABS(Cr) ) / ( 1. + ABS(Cr) )
+                  ! -- ospre --
+                  !!zpsi = 1.5 * ( Cr*Cr + Cr ) / ( Cr*Cr + Cr + 1. )
+                  ! -- koren --
+                  !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( (1.+2*Cr)/3., 2. ) ) )
+                  ! -- charm --
+                  !IF( Cr > 0. ) THEN   ;   zpsi = Cr * (3.*Cr + 1.) / ( (Cr + 1.) * (Cr + 1.) )
+                  !ELSE                 ;   zpsi = 0.
+                  !ENDIF
+                  ! -- van albada 1 --
+                  !!zpsi = (Cr*Cr + Cr) / (Cr*Cr +1)
+                  ! -- smart --
+                  !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( 0.25+0.75*Cr, 4. ) ) )
+                  ! -- umist --
+                  !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( 0.25+0.75*Cr, MIN(0.75+0.25*Cr, 2. ) ) ) )
+
+                  ! high order flux corrected by the limiter
+                  pfu_ho(ji,jj,jl) = pfu_ho(ji,jj,jl) - ABS( pu(ji,jj) ) * ( (1.-zpsi) + uCFL*zpsi ) * Rj * 0.5
+
                ENDIF
-
-               zh3 = pfu_ho(ji,jj) - pfu_ups(ji,jj)     
-               IF( Rj > 0. ) THEN
-                  zlimiter =  MAX( 0., MIN( zh3, MAX(-Rr * 0.5 * ABS(puc(ji,jj)),  &
-                     &        MIN( 2. * Rr * 0.5 * ABS(puc(ji,jj)),  zh3,  1.5 * Rj * 0.5 * ABS(puc(ji,jj)) ) ) ) )
-               ELSE
-                  zlimiter = -MAX( 0., MIN(-zh3, MAX( Rr * 0.5 * ABS(puc(ji,jj)),  &
-                     &        MIN(-2. * Rr * 0.5 * ABS(puc(ji,jj)), -zh3, -1.5 * Rj * 0.5 * ABS(puc(ji,jj)) ) ) ) )
-               ENDIF
-               pfu_ho(ji,jj) = pfu_ups(ji,jj) + zlimiter
-               
-            ELSE
-               IF( Rj /= 0. ) THEN
-                  IF( pu(ji,jj) > 0. ) THEN   ;   Cr = Rjm / Rj
-                  ELSE                        ;   Cr = Rjp / Rj
-                  ENDIF
-               ELSE
-                  Cr = 0.
-                  !IF( pu(ji,jj) > 0. ) THEN   ;   Cr = Rjm * 1.e20
-                  !ELSE                        ;   Cr = Rjp * 1.e20
-                  !ENDIF
-               ENDIF
-               
-               ! -- superbee --
-               zpsi = MAX( 0., MAX( MIN(1.,2.*Cr), MIN(2.,Cr) ) )
-               ! -- van albada 2 --
-               !!zpsi = 2.*Cr / (Cr*Cr+1.)
-
-               ! -- sweby (with beta=1) --
-               !!zpsi = MAX( 0., MAX( MIN(1.,1.*Cr), MIN(1.,Cr) ) )
-               ! -- van Leer --
-               !!zpsi = ( Cr + ABS(Cr) ) / ( 1. + ABS(Cr) )
-               ! -- ospre --
-               !!zpsi = 1.5 * ( Cr*Cr + Cr ) / ( Cr*Cr + Cr + 1. )
-               ! -- koren --
-               !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( (1.+2*Cr)/3., 2. ) ) )
-               ! -- charm --
-               !IF( Cr > 0. ) THEN   ;   zpsi = Cr * (3.*Cr + 1.) / ( (Cr + 1.) * (Cr + 1.) )
-               !ELSE                 ;   zpsi = 0.
-               !ENDIF
-               ! -- van albada 1 --
-               !!zpsi = (Cr*Cr + Cr) / (Cr*Cr +1)
-               ! -- smart --
-               !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( 0.25+0.75*Cr, 4. ) ) )
-               ! -- umist --
-               !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( 0.25+0.75*Cr, MIN(0.75+0.25*Cr, 2. ) ) ) )
-
-               ! high order flux corrected by the limiter
-               pfu_ho(ji,jj) = pfu_ho(ji,jj) - ABS( puc(ji,jj) ) * ( (1.-zpsi) + uCFL*zpsi ) * Rj * 0.5
-
-            ENDIF
+            END DO
          END DO
       END DO
-      CALL lbc_lnk( pfu_ho, 'U', -1.)   ! lateral boundary cond.
+      CALL lbc_lnk( 'icedyn_adv_umx', pfu_ho, 'U', -1.)   ! lateral boundary cond.
       !
    END SUBROUTINE limiter_x
@@ -1657,91 +1793,95 @@
       !! **  Purpose :   compute flux limiter 
       !!----------------------------------------------------------------------
-      REAL(wp)                     , INTENT(in   )           ::   pdt          ! tracer time-step
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(in   )           ::   pv           ! ice i-velocity => u*e2
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(in   )           ::   pvc          ! ice i-velocity *A => u*e2*a
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(in   )           ::   pt           ! ice tracer
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(inout)           ::   pfv_ho       ! high order flux
-      REAL(wp), DIMENSION (jpi,jpj), INTENT(in   ), OPTIONAL ::   pfv_ups      ! upstream flux
+      REAL(wp)                   , INTENT(in   )           ::   pdt          ! tracer time-step
+      REAL(wp), DIMENSION (:,:  ), INTENT(in   )           ::   pv           ! ice i-velocity => u*e2
+      REAL(wp), DIMENSION (:,:,:), INTENT(in   )           ::   pvc          ! ice i-velocity *A => u*e2*a
+      REAL(wp), DIMENSION (:,:,:), INTENT(in   )           ::   pt           ! ice tracer
+      REAL(wp), DIMENSION (:,:,:), INTENT(inout)           ::   pfv_ho       ! high order flux
+      REAL(wp), DIMENSION (:,:,:), INTENT(in   ), OPTIONAL ::   pfv_ups      ! upstream flux
       !
       REAL(wp) ::   Cr, Rjm, Rj, Rjp, vCFL, zpsi, zh3, zlimiter, Rr
-      INTEGER  ::   ji, jj    ! dummy loop indices
-      REAL(wp), DIMENSION (jpi,jpj) ::   zslpy       ! tracer slopes 
-      !!----------------------------------------------------------------------
-      !
-      DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1   ! vector opt.
-            zslpy(ji,jj) = ( pt(ji,jj+1) - pt(ji,jj) ) * vmask(ji,jj,1)
+      INTEGER  ::   ji, jj, jl    ! dummy loop indices
+      REAL(wp), DIMENSION (jpi,jpj,jpl) ::   zslpy       ! tracer slopes 
+      !!----------------------------------------------------------------------
+      !
+      DO jl = 1, jpl
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zslpy(ji,jj,jl) = ( pt(ji,jj+1,jl) - pt(ji,jj,jl) ) * vmask(ji,jj,1)
+            END DO
          END DO
       END DO
-      CALL lbc_lnk( zslpy, 'V', -1.)   ! lateral boundary cond.
-      
-      DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1   ! vector opt.
-            vCFL = pdt * ABS( pv(ji,jj) ) * r1_e1e2t(ji,jj)
-
-            Rjm = zslpy(ji,jj-1)
-            Rj  = zslpy(ji,jj  )
-            Rjp = zslpy(ji,jj+1)
-
-            IF( PRESENT(pfv_ups) ) THEN
-
-               IF( pv(ji,jj) > 0. ) THEN   ;   Rr = Rjm
-               ELSE                        ;   Rr = Rjp
+      CALL lbc_lnk( 'icedyn_adv_umx', zslpy, 'V', -1.)   ! lateral boundary cond.
+
+      DO jl = 1, jpl
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               vCFL = pdt * ABS( pv(ji,jj) ) * r1_e1e2t(ji,jj)
+
+               Rjm = zslpy(ji,jj-1,jl)
+               Rj  = zslpy(ji,jj  ,jl)
+               Rjp = zslpy(ji,jj+1,jl)
+
+               IF( PRESENT(pfv_ups) ) THEN
+
+                  IF( pv(ji,jj) > 0. ) THEN   ;   Rr = Rjm
+                  ELSE                        ;   Rr = Rjp
+                  ENDIF
+
+                  zh3 = pfv_ho(ji,jj,jl) - pfv_ups(ji,jj,jl)     
+                  IF( Rj > 0. ) THEN
+                     zlimiter =  MAX( 0., MIN( zh3, MAX(-Rr * 0.5 * ABS(pv(ji,jj)),  &
+                        &        MIN( 2. * Rr * 0.5 * ABS(pv(ji,jj)),  zh3,  1.5 * Rj * 0.5 * ABS(pv(ji,jj)) ) ) ) )
+                  ELSE
+                     zlimiter = -MAX( 0., MIN(-zh3, MAX( Rr * 0.5 * ABS(pv(ji,jj)),  &
+                        &        MIN(-2. * Rr * 0.5 * ABS(pv(ji,jj)), -zh3, -1.5 * Rj * 0.5 * ABS(pv(ji,jj)) ) ) ) )
+                  ENDIF
+                  pfv_ho(ji,jj,jl) = pfv_ups(ji,jj,jl) + zlimiter
+
+               ELSE
+
+                  IF( Rj /= 0. ) THEN
+                     IF( pv(ji,jj) > 0. ) THEN   ;   Cr = Rjm / Rj
+                     ELSE                        ;   Cr = Rjp / Rj
+                     ENDIF
+                  ELSE
+                     Cr = 0.
+                     !IF( pv(ji,jj) > 0. ) THEN   ;   Cr = Rjm * 1.e20
+                     !ELSE                        ;   Cr = Rjp * 1.e20
+                     !ENDIF
+                  ENDIF
+
+                  ! -- superbee --
+                  zpsi = MAX( 0., MAX( MIN(1.,2.*Cr), MIN(2.,Cr) ) )
+                  ! -- van albada 2 --
+                  !!zpsi = 2.*Cr / (Cr*Cr+1.)
+
+                  ! -- sweby (with beta=1) --
+                  !!zpsi = MAX( 0., MAX( MIN(1.,1.*Cr), MIN(1.,Cr) ) )
+                  ! -- van Leer --
+                  !!zpsi = ( Cr + ABS(Cr) ) / ( 1. + ABS(Cr) )
+                  ! -- ospre --
+                  !!zpsi = 1.5 * ( Cr*Cr + Cr ) / ( Cr*Cr + Cr + 1. )
+                  ! -- koren --
+                  !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( (1.+2*Cr)/3., 2. ) ) )
+                  ! -- charm --
+                  !IF( Cr > 0. ) THEN   ;   zpsi = Cr * (3.*Cr + 1.) / ( (Cr + 1.) * (Cr + 1.) )
+                  !ELSE                 ;   zpsi = 0.
+                  !ENDIF
+                  ! -- van albada 1 --
+                  !!zpsi = (Cr*Cr + Cr) / (Cr*Cr +1)
+                  ! -- smart --
+                  !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( 0.25+0.75*Cr, 4. ) ) )
+                  ! -- umist --
+                  !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( 0.25+0.75*Cr, MIN(0.75+0.25*Cr, 2. ) ) ) )
+
+                  ! high order flux corrected by the limiter
+                  pfv_ho(ji,jj,jl) = pfv_ho(ji,jj,jl) - ABS( pv(ji,jj) ) * ( (1.-zpsi) + vCFL*zpsi ) * Rj * 0.5
+
                ENDIF
-
-               zh3 = pfv_ho(ji,jj) - pfv_ups(ji,jj)     
-               IF( Rj > 0. ) THEN
-                  zlimiter =  MAX( 0., MIN( zh3, MAX(-Rr * 0.5 * ABS(pvc(ji,jj)),  &
-                     &        MIN( 2. * Rr * 0.5 * ABS(pvc(ji,jj)),  zh3,  1.5 * Rj * 0.5 * ABS(pvc(ji,jj)) ) ) ) )
-               ELSE
-                  zlimiter = -MAX( 0., MIN(-zh3, MAX( Rr * 0.5 * ABS(pvc(ji,jj)),  &
-                     &        MIN(-2. * Rr * 0.5 * ABS(pvc(ji,jj)), -zh3, -1.5 * Rj * 0.5 * ABS(pvc(ji,jj)) ) ) ) )
-               ENDIF
-               pfv_ho(ji,jj) = pfv_ups(ji,jj) + zlimiter
-
-            ELSE
-
-               IF( Rj /= 0. ) THEN
-                  IF( pv(ji,jj) > 0. ) THEN   ;   Cr = Rjm / Rj
-                  ELSE                        ;   Cr = Rjp / Rj
-                  ENDIF
-               ELSE
-                  Cr = 0.
-                  !IF( pv(ji,jj) > 0. ) THEN   ;   Cr = Rjm * 1.e20
-                  !ELSE                        ;   Cr = Rjp * 1.e20
-                  !ENDIF
-               ENDIF
-
-               ! -- superbee --
-               zpsi = MAX( 0., MAX( MIN(1.,2.*Cr), MIN(2.,Cr) ) )
-               ! -- van albada 2 --
-               !!zpsi = 2.*Cr / (Cr*Cr+1.)
-
-               ! -- sweby (with beta=1) --
-               !!zpsi = MAX( 0., MAX( MIN(1.,1.*Cr), MIN(1.,Cr) ) )
-               ! -- van Leer --
-               !!zpsi = ( Cr + ABS(Cr) ) / ( 1. + ABS(Cr) )
-               ! -- ospre --
-               !!zpsi = 1.5 * ( Cr*Cr + Cr ) / ( Cr*Cr + Cr + 1. )
-               ! -- koren --
-               !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( (1.+2*Cr)/3., 2. ) ) )
-               ! -- charm --
-               !IF( Cr > 0. ) THEN   ;   zpsi = Cr * (3.*Cr + 1.) / ( (Cr + 1.) * (Cr + 1.) )
-               !ELSE                 ;   zpsi = 0.
-               !ENDIF
-               ! -- van albada 1 --
-               !!zpsi = (Cr*Cr + Cr) / (Cr*Cr +1)
-               ! -- smart --
-               !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( 0.25+0.75*Cr, 4. ) ) )
-               ! -- umist --
-               !!zpsi = MAX( 0., MIN( 2.*Cr, MIN( 0.25+0.75*Cr, MIN(0.75+0.25*Cr, 2. ) ) ) )
-
-               ! high order flux corrected by the limiter
-               pfv_ho(ji,jj) = pfv_ho(ji,jj) - ABS( pvc(ji,jj) ) * ( (1.-zpsi) + vCFL*zpsi ) * Rj * 0.5
-
-            ENDIF
+            END DO
          END DO
       END DO
-      CALL lbc_lnk( pfv_ho, 'V', -1.)   ! lateral boundary cond.
+      CALL lbc_lnk( 'icedyn_adv_umx', pfv_ho, 'V', -1.)   ! lateral boundary cond.
       !
    END SUBROUTINE limiter_y
Index: /NEMO/trunk/src/ICE/icedyn_rdgrft.F90
===================================================================
--- /NEMO/trunk/src/ICE/icedyn_rdgrft.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/icedyn_rdgrft.F90	(revision 10425)
@@ -91,6 +91,6 @@
          &      ze_i_2d(jpij,nlay_i,jpl), ze_s_2d(jpij,nlay_s,jpl), STAT=ice_dyn_rdgrft_alloc )
 
-      IF( lk_mpp                    )   CALL mpp_sum ( ice_dyn_rdgrft_alloc )
-      IF( ice_dyn_rdgrft_alloc /= 0 )   CALL ctl_warn( 'ice_dyn_rdgrft_alloc: failed to allocate arrays' )
+      CALL mpp_sum ( 'icedyn_rdgrft', ice_dyn_rdgrft_alloc )
+      IF( ice_dyn_rdgrft_alloc /= 0 )   CALL ctl_stop( 'STOP',  'ice_dyn_rdgrft_alloc: failed to allocate arrays'  )
       !
    END FUNCTION ice_dyn_rdgrft_alloc
@@ -269,5 +269,5 @@
             !
             iter = iter + 1
-            IF( iter  >  jp_itermax )    CALL ctl_warn( 'icedyn_rdgrft: non-converging ridging scheme' )
+            IF( iter  >  jp_itermax )    CALL ctl_stop( 'STOP',  'icedyn_rdgrft: non-converging ridging scheme'  )
             !
          END DO
@@ -793,5 +793,5 @@
             END DO
          END DO
-         CALL lbc_lnk( strength, 'T', 1. )
+         CALL lbc_lnk( 'icedyn_rdgrft', strength, 'T', 1. )
          !
       CASE( 2 )               !--- Temporal smoothing
@@ -814,5 +814,5 @@
             END DO
          END DO
-         CALL lbc_lnk( strength, 'T', 1. )
+         CALL lbc_lnk( 'icedyn_rdgrft', strength, 'T', 1. )
          !
       END SELECT
Index: /NEMO/trunk/src/ICE/icedyn_rhg_evp.F90
===================================================================
--- /NEMO/trunk/src/ICE/icedyn_rhg_evp.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/icedyn_rhg_evp.F90	(revision 10425)
@@ -146,5 +146,5 @@
       REAL(wp), DIMENSION(jpi,jpj) ::   zds                             ! shear
       REAL(wp), DIMENSION(jpi,jpj) ::   zs1, zs2, zs12                  ! stress tensor components
-      REAL(wp), DIMENSION(jpi,jpj) ::   zu_ice, zv_ice, zresr           ! check convergence
+!!$      REAL(wp), DIMENSION(jpi,jpj) ::   zu_ice, zv_ice, zresr           ! check convergence
       REAL(wp), DIMENSION(jpi,jpj) ::   zsshdyn                         ! array used for the calculation of ice surface slope:
       !                                                                 !    ocean surface (ssh_m) if ice is not embedded
@@ -193,5 +193,5 @@
          END DO
       END DO
-      CALL lbc_lnk( zfmask, 'F', 1._wp )
+      CALL lbc_lnk( 'icedyn_rhg_evp', zfmask, 'F', 1._wp )
 
       ! Lateral boundary conditions on velocity (modify zfmask)
@@ -220,5 +220,5 @@
          ENDIF
       END DO
-      CALL lbc_lnk( zfmask, 'F', 1._wp )
+      CALL lbc_lnk( 'icedyn_rhg_evp', zfmask, 'F', 1._wp )
 
       !------------------------------------------------------------------------------!
@@ -322,5 +322,5 @@
          END DO
       END DO
-      CALL lbc_lnk_multi( zmf, 'T', 1., zdt_m, 'T', 1. )
+      CALL lbc_lnk_multi( 'icedyn_rhg_evp', zmf, 'T', 1., zdt_m, 'T', 1. )
       !
       !                                  !== Landfast ice parameterization ==!
@@ -343,5 +343,5 @@
             END DO
          END DO
-         CALL lbc_lnk( tau_icebfr(:,:), 'T', 1. )
+         CALL lbc_lnk( 'icedyn_rhg_evp', tau_icebfr(:,:), 'T', 1. )
          !
       ELSEIF( ln_landfast_home ) THEN          !-- Home made
@@ -370,10 +370,12 @@
       DO jter = 1 , nn_nevp                           !    loop over jter    !
          !                                            !----------------------!        
-         IF(ln_ctl) THEN   ! Convergence test
-            DO jj = 1, jpjm1
-               zu_ice(:,jj) = u_ice(:,jj) ! velocity at previous time step
-               zv_ice(:,jj) = v_ice(:,jj)
-            END DO
-         ENDIF
+         l_full_nf_update = jter == nn_nevp   ! false: disable full North fold update (performances) for iter = 1 to nn_nevp-1
+         !
+!!$         IF(ln_ctl) THEN   ! Convergence test
+!!$            DO jj = 1, jpjm1
+!!$               zu_ice(:,jj) = u_ice(:,jj) ! velocity at previous time step
+!!$               zv_ice(:,jj) = v_ice(:,jj)
+!!$            END DO
+!!$         ENDIF
 
          ! --- divergence, tension & shear (Appendix B of Hunke & Dukowicz, 2002) --- !
@@ -388,5 +390,5 @@
             END DO
          END DO
-         CALL lbc_lnk( zds, 'F', 1. )
+         CALL lbc_lnk( 'icedyn_rhg_evp', zds, 'F', 1. )
 
          DO jj = 2, jpj    ! loop to jpi,jpj to avoid making a communication for zs1,zs2,zs12
@@ -432,5 +434,5 @@
             END DO
          END DO
-         CALL lbc_lnk( zp_delt, 'T', 1. )
+         CALL lbc_lnk( 'icedyn_rhg_evp', zp_delt, 'T', 1. )
 
          DO jj = 1, jpjm1
@@ -527,5 +529,5 @@
                END DO
             END DO
-            CALL lbc_lnk( v_ice, 'V', -1. )
+            CALL lbc_lnk( 'icedyn_rhg_evp', v_ice, 'V', -1. )
             !
 #if defined key_agrif
@@ -575,5 +577,5 @@
                END DO
             END DO
-            CALL lbc_lnk( u_ice, 'U', -1. )
+            CALL lbc_lnk( 'icedyn_rhg_evp', u_ice, 'U', -1. )
             !
 #if defined key_agrif
@@ -625,5 +627,5 @@
                END DO
             END DO
-            CALL lbc_lnk( u_ice, 'U', -1. )
+            CALL lbc_lnk( 'icedyn_rhg_evp', u_ice, 'U', -1. )
             !
 #if defined key_agrif
@@ -673,5 +675,5 @@
                END DO
             END DO
-            CALL lbc_lnk( v_ice, 'V', -1. )
+            CALL lbc_lnk( 'icedyn_rhg_evp', v_ice, 'V', -1. )
             !
 #if defined key_agrif
@@ -682,12 +684,12 @@
             !
          ENDIF
-         
-         IF(ln_ctl) THEN   ! Convergence test
-            DO jj = 2 , jpjm1
-               zresr(:,jj) = MAX( ABS( u_ice(:,jj) - zu_ice(:,jj) ), ABS( v_ice(:,jj) - zv_ice(:,jj) ) )
-            END DO
-            zresm = MAXVAL( zresr( 1:jpi, 2:jpjm1 ) )
-            IF( lk_mpp )   CALL mpp_max( zresm )   ! max over the global domain
-         ENDIF
+
+!!$         IF(ln_ctl) THEN   ! Convergence test
+!!$            DO jj = 2 , jpjm1
+!!$               zresr(:,jj) = MAX( ABS( u_ice(:,jj) - zu_ice(:,jj) ), ABS( v_ice(:,jj) - zv_ice(:,jj) ) )
+!!$            END DO
+!!$            zresm = MAXVAL( zresr( 1:jpi, 2:jpjm1 ) )
+!!$            CALL mpp_max( 'icedyn_rhg_evp', zresm )   ! max over the global domain
+!!$         ENDIF
          !
          !                                                ! ==================== !
@@ -738,8 +740,8 @@
          END DO
       END DO
-      CALL lbc_lnk_multi( pshear_i, 'T', 1., pdivu_i, 'T', 1., pdelta_i, 'T', 1. )
+      CALL lbc_lnk_multi( 'icedyn_rhg_evp', pshear_i, 'T', 1., pdivu_i, 'T', 1., pdelta_i, 'T', 1. )
       
       ! --- Store the stress tensor for the next time step --- !
-      CALL lbc_lnk_multi( zs1, 'T', 1., zs2, 'T', 1., zs12, 'F', 1. )
+      CALL lbc_lnk_multi( 'icedyn_rhg_evp', zs1, 'T', 1., zs2, 'T', 1., zs12, 'F', 1. )
       pstress1_i (:,:) = zs1 (:,:)
       pstress2_i (:,:) = zs2 (:,:)
@@ -785,5 +787,5 @@
             END DO
          END DO
-         CALL lbc_lnk_multi( zsig1, 'T', 1., zsig2, 'T', 1., zsig3, 'T', 1. )
+         CALL lbc_lnk_multi( 'icedyn_rhg_evp', zsig1, 'T', 1., zsig2, 'T', 1., zsig3, 'T', 1. )
          !
          IF( iom_use('isig1') )   CALL iom_put( "isig1" , zsig1 )
@@ -842,10 +844,10 @@
          END DO
          
-         CALL lbc_lnk_multi( zdiag_sig1   , 'T',  1., zdiag_sig2   , 'T',  1.,   &
+         CALL lbc_lnk_multi( 'icedyn_rhg_evp', zdiag_sig1   , 'T',  1., zdiag_sig2   , 'T',  1.,   &
             &                zdiag_dssh_dx, 'U', -1., zdiag_dssh_dy, 'V', -1.,   &
             &                zdiag_corstrx, 'U', -1., zdiag_corstry, 'V', -1.,   & 
             &                zdiag_intstrx, 'U', -1., zdiag_intstry, 'V', -1.    )
                   
-         CALL lbc_lnk_multi( zdiag_utau_oi  , 'U', -1., zdiag_vtau_oi  , 'V', -1.,   &
+         CALL lbc_lnk_multi( 'icedyn_rhg_evp', zdiag_utau_oi  , 'U', -1., zdiag_vtau_oi  , 'V', -1.,   &
             &                zdiag_xmtrp_ice, 'U', -1., zdiag_xmtrp_snw, 'U', -1.,   &
             &                zdiag_xatrp    , 'U', -1., zdiag_ymtrp_ice, 'V', -1.,   &
Index: /NEMO/trunk/src/ICE/iceforcing.F90
===================================================================
--- /NEMO/trunk/src/ICE/iceforcing.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/iceforcing.F90	(revision 10425)
@@ -83,5 +83,5 @@
             END DO
          END DO
-         CALL lbc_lnk_multi( utau_ice, 'U', -1., vtau_ice, 'V', -1. )
+         CALL lbc_lnk_multi( 'iceforcing', utau_ice, 'U', -1., vtau_ice, 'V', -1. )
       ENDIF
       !
Index: /NEMO/trunk/src/ICE/iceistate.F90
===================================================================
--- /NEMO/trunk/src/ICE/iceistate.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/iceistate.F90	(revision 10425)
@@ -414,4 +414,6 @@
       u_ice (:,:) = 0._wp
       v_ice (:,:) = 0._wp
+      ! fields needed for ice_dyn_adv_umx
+      l_split_advumx(1) = .FALSE.
       !
       !----------------------------------------------
@@ -483,5 +485,5 @@
 !!clem: output of initial state should be written here but it is impossible because
 !!      the ocean and ice are in the same file
-!!      CALL dia_wri_state( 'output.init', nit000 )
+!!      CALL dia_wri_state( 'output.init' )
       !
    END SUBROUTINE ice_istate
Index: /NEMO/trunk/src/ICE/icerst.F90
===================================================================
--- /NEMO/trunk/src/ICE/icerst.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/icerst.F90	(revision 10425)
@@ -69,8 +69,5 @@
             IF(lwp) THEN
                WRITE(numout,*)
-               SELECT CASE ( jprstlib )
-               CASE DEFAULT
-                  WRITE(numout,*) '             open ice restart NetCDF file: ',TRIM(clpath)//clname
-               END SELECT
+               WRITE(numout,*) '             open ice restart NetCDF file: ',TRIM(clpath)//clname
                IF( kt == nitrst - 2*nn_fsbc + 1 ) THEN
                   WRITE(numout,*) '             kt = nitrst - 2*nn_fsbc + 1 = ', kt,' date= ', ndastp
@@ -80,5 +77,5 @@
             ENDIF
             !
-            CALL iom_open( TRIM(clpath)//TRIM(clname), numriw, ldwrt = .TRUE., kiolib = jprstlib, kdlev = jpl )
+            CALL iom_open( TRIM(clpath)//TRIM(clname), numriw, ldwrt = .TRUE., kdlev = jpl )
             lrst_ice = .TRUE.
          ENDIF
@@ -98,5 +95,5 @@
       INTEGER, INTENT(in) ::   kt     ! number of iteration
       !!
-      INTEGER ::   jk ,jl   ! dummy loop indices
+      INTEGER ::   jk    ! dummy loop indices
       INTEGER ::   iter
       CHARACTER(len=25) ::   znam
@@ -118,4 +115,5 @@
       CALL iom_rstput( iter, nitrst, numriw, 'nn_fsbc', REAL( nn_fsbc, wp ) )      ! time-step 
       CALL iom_rstput( iter, nitrst, numriw, 'kt_ice' , REAL( iter   , wp ) )      ! date
+      CALL iom_delay_rst( 'WRITE', 'ICE', numriw )   ! save only ice delayed global communication variables
 
       ! Prognostic variables
@@ -169,8 +167,7 @@
       !! ** purpose  :   read restart file
       !!----------------------------------------------------------------------
-      INTEGER           ::   jk, jl
+      INTEGER           ::   jk
       LOGICAL           ::   llok
       INTEGER           ::   id1            ! local integer
-      INTEGER           ::   jlibalt = jprstlib
       CHARACTER(len=25) ::   znam
       CHARACTER(len=2)  ::   zchar, zchar1
@@ -185,5 +182,5 @@
       ENDIF
 
-      CALL iom_open ( TRIM(cn_icerst_indir)//'/'//cn_icerst_in, numrir, kiolib = jprstlib, kdlev = jpl )
+      CALL iom_open ( TRIM(cn_icerst_indir)//'/'//cn_icerst_in, numrir, kdlev = jpl )
 
       CALL iom_get( numrir, 'nn_fsbc', zfice )
@@ -236,4 +233,7 @@
       CALL iom_get( numrir, jpdom_autoglo, 'u_ice', u_ice )
       CALL iom_get( numrir, jpdom_autoglo, 'v_ice', v_ice )
+
+      CALL iom_delay_rst( 'READ', 'ICE', numrir )   ! read only ice delayed global communication variables
+
       ! fields needed for Met Office (Jules) coupling
       IF( ln_cpl ) THEN
Index: /NEMO/trunk/src/ICE/icestp.F90
===================================================================
--- /NEMO/trunk/src/ICE/icestp.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/icestp.F90	(revision 10425)
@@ -241,5 +241,5 @@
       ierr = ierr + ice1D_alloc      ()      ! thermodynamics
       !
-      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      CALL mpp_sum( 'icestp', ierr )
       IF( ierr /= 0 )   CALL ctl_stop('STOP', 'ice_init : unable to allocate ice arrays')
       !
Index: /NEMO/trunk/src/ICE/icethd.F90
===================================================================
--- /NEMO/trunk/src/ICE/icethd.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/icethd.F90	(revision 10425)
@@ -126,5 +126,5 @@
          END DO
       ENDIF
-      CALL lbc_lnk( zfric, 'T',  1. )
+      CALL lbc_lnk( 'icethd', zfric, 'T',  1. )
       !
       !--------------------------------------------------------------------!
@@ -212,6 +212,4 @@
          END DO
 
-         IF( lk_mpp )         CALL mpp_ini_ice( npti , numout )
-
          IF( npti > 0 ) THEN  ! If there is no ice, do nothing.
             !                                                                
@@ -250,5 +248,4 @@
             !                                                       ! --- & Move to 2D arrays --- !
             !
-            IF( lk_mpp )      CALL mpp_comm_free( ncomm_ice ) !RB necessary ??
          ENDIF
          !
Index: /NEMO/trunk/src/ICE/icethd_do.F90
===================================================================
--- /NEMO/trunk/src/ICE/icethd_do.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/icethd_do.F90	(revision 10425)
@@ -189,5 +189,5 @@
          END DO 
          ! 
-         CALL lbc_lnk_multi( zvrel, 'T', 1., ht_i_new, 'T', 1.  )
+         CALL lbc_lnk_multi( 'icethd_do', zvrel, 'T', 1., ht_i_new, 'T', 1.  )
 
       ENDIF
